#include "main.h"






////-----------16x2-------LCD_ 4_ BIT---------D4,D5,D6,D7-------------------------------------------
//void wr_lcdport(unsigned char temp)
//{
//	unsigned int temp1;
//	temp &= 0x0f;
//	temp1  = (unsigned int)temp;
//	LCD_PORT & = 0xfff0;
//	LCD_PORT |= temp1;
//}
////----------------------------------------------------------------------

//void wr_lcdbyte(unsigned char lcdbyte)
//{
////wr_lcdbyte code
//	unsigned char temp;
//	temp = lcdbyte;			//write upper nibble of lcdbyte
//	temp &= 0xf0;
//	temp = temp >> 4;
//	SET_HI_lcden_hbit;
//	wr_lcdport(temp);
//	asm("nop");
//	asm("nop");
/*	lcd_smalldelay();
	SET_LO_lcden_hbit;
//
	temp = lcdbyte;			//write lower nibble of lcdbyte
	temp &= 0x0f;
	SET_HI_lcden_hbit;
	wr_lcdport(temp);
	asm("nop");
	asm("nop");
	lcd_smalldelay();
	SET_LO_lcden_hbit;
	lcd_smalldelay();
}
*/

////----------------------------------------------------------------------
//void init_lcd(void)
//{
//	//signal_good();		//long delay upon power up.
//	SET_LO_lcdrs_hbit;
//	delay_ms(15);
//	SET_LO_lcdrs_hbit;
//	wr_lcdport(0x02);	//Function set Data Length = 4bits
//
//	SET_HI_lcden_hbit;
//	asm("nop");
//	asm("nop");
//   asm("nop");
//   asm("nop");
////    asm("nop");
////	asm("nop");
//	lcd_smalldelay();
//	SET_LO_lcden_hbit;
////
//delay_ms(10);
//	lcd_com_wr(0x28);	//DL=4Bits, N=2Lines, F=5x7
//	lcd_com_wr(0x0c); 	//Disp Control, Disp=On, Cursor & Blink = Off
//	lcd_com_wr(0x06);	//Cursor moves right, no shift
//	lcd_com_wr(0x01);	//Clear Display Junks
//	delay_ms(5);
//}

///==============================================================================

//----------16x2--------LCD_ 8_ BIT---------D4,D5,D6,D7-------------------------------------------
void wr_lcdport(unsigned char temp)
{
	
	LCD_PORT = temp;
}

//----------------------------------------------------------------------
void wr_lcdbyte(unsigned char lcdbyte)
{
//wr_lcdbyte code
	unsigned char temp;
	temp = lcdbyte;			//write upper nibble of lcdbyte
	SET_HI_lcden_hbit;
	wr_lcdport(temp);
	asm("nop");
	asm("nop");
	lcd_smalldelay();
	SET_LO_lcden_hbit;

	
}

//----------------------------------------------------------------------
void lcd_wrdelay(void)
{
	unsigned int temp;
	for(temp = 4000; temp !=0; temp--) {}
}
//----------------------------------------------------------------------
void lcd_smalldelay(void)
{
	unsigned char i;
	for(i=0; i!=100; i++){}
}
//----------------------------------------------------------------------
void init_lcd(void)
{
	//signal_good();		//long delay upon power up.
	SET_LO_lcdrs_hbit;
    SET_LO_lcdrs_hbit;
	delay_ms(15);
	SET_LO_lcdrs_hbit;
//	wr_lcdport(0x02);	//Function set Data Length = 4bits


	SET_HI_lcden_hbit;
	asm("nop");
	asm("nop");
    asm("nop");
	asm("nop");
    asm("nop");
	asm("nop");
	lcd_smalldelay();
	SET_LO_lcden_hbit;

	delay_ms(10);

	lcd_com_wr(0x38);	//DL=8Bits, N=2Lines, F=5x7
	lcd_com_wr(0x0c); 	//Disp Control, Disp=On, Cursor & Blink = Off
	lcd_com_wr(0x06);	//Cursor moves right, no shift
	lcd_com_wr(0x01);	//Clear Display Junks
	delay_ms(5);
}
//----------------------------------------------------------------------
void lcd_com_wr(unsigned char command)
{
//lcd_com_wr code
//disable global interrupt if reqd.
	SET_LO_lcdrs_hbit;			//select command register
	wr_lcdbyte(command);
}

//----------------------------------------------------------------------
void lcd_data_wr(unsigned char dataa)
{
//lcd_data_wr code
	//disable global interrupt if reqd.
	SET_HI_lcdrs_hbit;			//select data register
	wr_lcdbyte(dataa);
}

//----------------------------------------------------------------------
void lcd_comdata_wr(unsigned char command,unsigned char dta)
{
	lcd_com_wr(command);
	lcd_data_wr(dta);
}


//----------------------------------------------------------------------
void lcd_arraywr_rom(unsigned char lcd_startaddr, unsigned char* array_start_ptr)
{
//lcd_arraywr_rom code
//Writes the string stored in ROM onto the display till $ (or equivalent) is encountered

	unsigned char temp;
    
    
	lcd_com_wr(lcd_startaddr);

	while(1)
	{
		temp = *array_start_ptr;
		if(temp == '$') return;
		lcd_data_wr(temp);
		array_start_ptr++;
	}
}

//------------------------------------------------------------------------------

void lcd_arraywr_ram(unsigned char lcd_startaddr,unsigned char * array_start_ptr, unsigned char counts)
{
	unsigned char temp;
	lcd_com_wr(lcd_startaddr);

	do
	{	temp = *array_start_ptr;
		lcd_data_wr(temp);
		array_start_ptr++;
		counts--;
	}while(counts !=0);
}
///--------------------------------------------------------------------------
void lcd_clear( void)
{
  lcd_com_wr( 0x01 );
}

//==============================================================================
