#include"main.h"
#include"extern2.h"

bit basems_flg;
unsigned char health_cntr;
unsigned int k;
unsigned char rx_flg = 0;
unsigned char data;
unsigned char bcd_array[8];
unsigned int Dat1,Dat2;
bit start;

union int_char
{
	unsigned int int_val;
	unsigned char char_val[2];
};

union int_char un2;

void health_flash(void)
{
    health_cntr++;
    if(health_cntr != 250)return;
    health_cntr = 0;
    HEALTH_LED = ~HEALTH_LED;

}

////------------------------------MODBUS------------------------------------------
//unsigned char mbus_rx_tmr;
unsigned char mbus_receive_tmr;
unsigned char mbus_tx_buff[20];
unsigned char mbus_rx_buff[20];
unsigned char mbus_rx[10];
unsigned char send_frame_cmpr;
unsigned char mbus_rx_framecmplt_flg;
unsigned char mbus_rx_framestart_flg;
unsigned char frame_send_flag;
unsigned char mbus_send_ptr,mbus_ptr;
unsigned char slave_id = 1;
//unsigned char mbus_rx_tmr;
//================================MODBUS========================================
//unsigned char slave_id=1;
//
//unsigned char mbus_rx_buff[180];
//unsigned char mbus_tx_buff[180];
//unsigned char mbus_rx_framecmplt_flg=0;
//unsigned char mbus_rx_framestart_flg=0;
//unsigned int mbus_receive_tmr=0;
//unsigned char mbus_ptr=0;
//unsigned char mbus_send_frame_flg=0;
//unsigned char mbus_send_ptr=0;
//unsigned char mbus_send_frame_len=0;
//unsigned char uart_newrx_flg=0;
//==============================================================================


static void interrupt isr(void)
{
    GIE = 0;
    if(TMR1IF == 1)
    {
        TMR1IF = 0;       
        health_flash();
        TMR1H = 0xec;
        TMR1L = 0x77;
        basems_flg = 1;
    }
    
    //-------------------------MODBUS CODE------------------------------------//
    
    if(mbus_rx_framestart_flg == 1)
    {  
        if(mbus_receive_tmr < 5) mbus_receive_tmr++;
    }
    else mbus_receive_tmr = 0;
    
    if(mbus_receive_tmr == 5)           //FRAME BROKEN TIME SET AS 5 MSEC
    {
        mbus_rx_framestart_flg = 0;
        mbus_rx_framecmplt_flg = 1;
    }
    //------------------------------------------------------------------------//
    
//    if(RCIF == 1)
//    {	
//        RCIF = 0;   
//        k = RCREG;
//        rx_flg = 1;
//        //send_byte(uart_data + 0x01);
//        
//        
////        mbus_rx_buff[mbus_ptr] = RCREG;
////        mbus_ptr++;
////        mbus_rx_framestart_flg = 1;
////        mbus_rx_tmr = 0;
//    }
    
	if(RCIF == 1)
    {	
        RCIF = 0;          
        mbus_rx_buff[mbus_ptr] = RCREG;
        mbus_ptr++;
        mbus_rx_framestart_flg = 1;
        mbus_receive_tmr = 0;
    }
    
    GIE = 1;    
}

void init(void)
{
//    ANSEL = 0X00;
    CMCON = 0x07;
    CVRCON = 0x00;
    ADCON1 = 0x00;
    
    
    CHS0 = 0;
    CHS1 = 0;
    CHS2 = 0;
    
//    LATA = 0x00;
    
    TRISA = 0X00;
    TRISB = 0X00;
    TRISC = 0X00;
    TRISD = 0X00;
    
    PORTA = 0X00;
    PORTB = 0X00;
    PORTC = 0X00;
    PORTD = 0X00;
    
}

void init_timr1(void)
{
    TMR1IE = 1;
    GIE    = 1;
    PEIE   = 1;
    TMR1IF = 0;
    TMR1H = 0xEc;	 
    TMR1L = 0x77;
    T1CON = 0x01;
}

void uart_init(void)
{
    TRISC7 = 1;             //RX_PIN NO 1
	TRISC6 = 0;             //TX_PIN NO 44
    
//    TXEN_hbit = 0;
    
    BRGH = 1;               //for 2400 BRGH = 1;SYNC = 0 BRG16 = 1;SPBRGL = 0x04;SPBRGH = 0x0D;	
	SYNC = 0;
    SPEN = 1;
//	BRG16 = 0;	
  	SPBRG = 129;           //BAUD RATE 9600 FOR 32MHZ IS 207 AND FOR 8MHZ IS 51												
//	SPBRGH = 0;
	
	ADDEN = 0;
	TX9 = 0;
	RX9 = 0;
    
	TXSTA = 0x24;
	TXEN = 1;
    CREN = 1;
    RCIF = 0;
    TXIF = 0;
	
	RCIE = 1 ;
    GIE = 1;
    PEIE = 1;
	RCSTA = 0x90;

	
	
    
    MAX_485_PIN  = 0;
}

void send_byte(unsigned char send_byte)
{
	unsigned int i=0;
//    
    TXEN = 1;
	while(TXIF == 0){}
	TXIF = 0;
	TXEN_hbit = 1;
	MAX_485_PIN = 1;
    TXEN = 1;
	//TX9D = calculate_parity(send_byte);
	
	TXREG = send_byte;
    TXEN = 1;
//    data = TXREG;
//    k = TXREG;
//    for(i=0;i<550;i++)
//	{	
//        asm("nop");asm("nop");
//	}
    TXEN = 1;
    MAX_485_PIN  = 0;
}

//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
unsigned char calculate_parity(unsigned char val)
{

    unsigned char i,counter;
    counter = 0;

    for(i=0;i<8;i++)
    {
        if((val & 0x01) == 0x01)
            counter++;
        val >>= 1;
    }

    return(counter & 0x01);
  
}

//------------------------------------------------------------------------------

void send_to_master(void)
{
	unsigned int i = 0;
//	
//    if(frame_send_flag == 0)return;
//    
//   
//    if(mbus_send_ptr > send_frame_cmpr)
//    {
//        send_frame_cmpr = 0;
//        frame_send_flag = 0;
//        mbus_send_ptr = 0;
//        mbus_ptr = 0;
//        
//        return;
//    }
    
	while(TXIF==0){}
	TXIF = 0;
	TXEN_hbit = 1;
	MAX_485_PIN  = 1;
    
//	TX9D = calculate_parity(mbus_tx_buff[mbus_send_ptr]);
	
    TXREG = mbus_tx_buff[mbus_send_ptr];
    mbus_send_ptr++;
    
//    for(i=0;i<500;i++)
//	{	
//        asm("nop");
//	}
    MAX_485_PIN = 0;
}

//------------------------------------------------------------------------------

void decode_mbus_frame(void)
{
  
    if(mbus_rx_framecmplt_flg == 0)return;
   
    
    union int_char un1;  
    unsigned int temp;
    
    mbus_rx_framestart_flg = 0;
    mbus_rx_framecmplt_flg = 0;
    mbus_receive_tmr = 0;
	
     
    if(mbus_rx_buff[0] != slave_id) 
    {
        mbus_ptr = 0;
        return;
    }
    
    temp = CRC_16(mbus_rx_buff,mbus_ptr-2);       //mbus -2 defines length of data
    un1.char_val[HIGHBYTE] = mbus_rx_buff[mbus_ptr-1];
    un1.char_val[LOWBYTE]  = mbus_rx_buff[mbus_ptr-2];
 
	if(un1.int_val != temp)
    {  
        mbus_ptr = 0;
        return;
    }

    un1.char_val[LOWBYTE] = mbus_rx_buff[4];
    un1.char_val[HIGHBYTE] = mbus_rx_buff[3];
    mbus_rx[0] = mbus_rx_buff[4];
    mbus_rx[1] = mbus_rx_buff[3];
    Dat1 = un1.int_val;                                          //read address
    
    un1.char_val[LOWBYTE] = mbus_rx_buff[6];
    un1.char_val[HIGHBYTE] = mbus_rx_buff[5];
    mbus_rx[2] = mbus_rx_buff[6];
    mbus_rx[3] = mbus_rx_buff[5];
    Dat2 = un1.int_val;                                             //read length

    
}	
//===============================================================================

void basems_wait(void)
{
    while(basems_flg == 0){}
    basems_flg = 0;
    decode_mbus_frame();        
//    send_to_master();
}


void delay_ms(unsigned int ms)
{
	while(ms > 0)
	{
		ms--;
        basems_wait();
	}
}

void clr_bcd_array(void)
{
	unsigned char i;
	for(i = 0; i != 8; i++)
		bcd_array[i] = 0;
}



const unsigned int subval_tbl[4] = {1000,100,10,1};
//-----------------------------------------------------------------
void int2bcd_4dig(unsigned int intval)
{
	//hex 2 bcd of 4 dig.
	//stores result in BCD_ARRAY
	//BCD_ARRAY[0] is the MSD
	unsigned char i;
	clr_bcd_array();

	for(i=0; i!=3; i++)
	{
		while(intval >= subval_tbl[i])
		{
			intval -= subval_tbl[i];
			bcd_array[i] = bcd_array[i] + 1;
		}
	}
		bcd_array[3] = intval;
}

void disp_adcval(unsigned char lcdadr, unsigned int value)
{
	int2bcd_4dig(value);
	bcd_array[0]+=0x30;
	bcd_array[1]+=0x30;
	bcd_array[2]+=0x30;
	bcd_array[3]+=0x30;
	lcd_arraywr_ram(lcdadr,bcd_array,4);
}

//void Uart1PutString(char *string)
//{
//    unsigned char c;
//    while( (c = *(string++)) )
//        send_byte(c);
//}

//------------------------------------------------------------------------------

unsigned int CRC_16(unsigned char *ptr,unsigned char cnts)
{
	union int_char crcreg;
	unsigned char i;
	crcreg.int_val = 0xffff;
    while(cnts != 0)
	{
		crcreg.char_val[LOWBYTE] ^= *ptr;
		for(i=8; i!=0; i--)
		{
			if(crcreg.char_val[LOWBYTE] & 0x01 == 1)
			{	crcreg.int_val = crcreg.int_val>>1;
				crcreg.int_val ^= 0xa001;
			}
			else
			{
                crcreg.int_val= crcreg.int_val>>1;
			}
		}
		
		cnts--;
		ptr++;
	}
	return(crcreg.int_val);
}

//------------------------------------------------------------------------------


void main(void) 

{
    init();                                                                                                         
    init_timr1();
    init_lcd();
    uart_init();        
    unsigned char j = 6;
    while(1)
    {
        basems_wait();   
        start = 0;
        lcd_arraywr_rom(0X80,"Hi$");
        delay_ms(5000);        
        if(start == 0)
        {
            if(start == 1) return;
            lcd_arraywr_rom(0X85,"start$");
            mbus_tx_buff[0] = 0x01;              //slave Id
            mbus_tx_buff[1] = 0x04;              // Function 
            mbus_tx_buff[2] = 0x00;              // ADD hi            
            mbus_tx_buff[3] = 0x96;              // ADD low
            mbus_tx_buff[4] = 0x00;              // no of points hi
            mbus_tx_buff[5] = 0x02;              // no of points low
    //        mbus_tx_buff[0] = 0x01;
            un2.int_val = CRC_16(mbus_tx_buff,6);
            j++;
            mbus_tx_buff[j] =  un2.char_val[LOWBYTE];
            j++;
            mbus_tx_buff[j] =  un2.char_val[HIGHBYTE];
            start = 1;
            send_to_master();
        }
        lcd_arraywr_rom(0X8a,"stop$");
        lcd_arraywr_ram(0xc8,mbus_rx, 8);
        send_byte(mbus_rx[0]);
        send_byte(mbus_rx[1]);
        send_byte(mbus_rx[2]);
        send_byte(mbus_rx[3]);
        disp_adcval(0xc0, Dat1);
        disp_adcval(0xc4, Dat2);
        
//        Uart1PutString(mbus_tx_buff);
        
//        Uart1PutString("Hello");
//        RA0 = 1;        
//        send_byte('A');
//        disp_adcval(0xc0, data);
//        if(rx_flg == 1)
//        {                        
//            send_byte(k+1);            
//            rx_flg = 0;
//        }
//        
        
//        
    }
    
}
